#define __NEW_STARLET
#include <syidef.h>
#include <stdlib.h>
#include <starlet.h>
#include <iccdef.h>
#include <iledef.h>
#include <stdio.h>
#include <descrip.h>
#include <lib$routines.h>
#include <iosbdef.h>
#include <string.h>
#include <ssdef.h>
#include <stsdef.h>
#include <iosbdef.h>
#include <iodef.h>

#define check(STS) if(!$VMS_STATUS_SUCCESS(STS)) sys$exit(STS)

#define MAX_BUFF 1000
#define NUM_MSGS 1000000

/* Prototype for the REQUIRED connection ast routine. */
void        conn_ast (unsigned int event_type, unsigned int c_handle,
		      unsigned int data_len, char *data_buff,
		      unsigned int p5,
		      unsigned int p6,
		      char *p7);

/* Static storage is used to pass connection handle back to main.
 * This is a little unstructured, but there is little alternative in this
 * simple design. */
static int  Handle;
static unsigned int Efn;

int main (void) {
  int         status;
  int         a_handle;
  unsigned short   channel;
  IOSB        iosb;
  char        info[MAX_BUFF];
  $DESCRIPTOR(mbxName, "SIMPLE_SERVER_MBX");
  int         acc_len;
  char        u_data[] = "Fan mail from a flounder.";
  char        buffer[BUFSIZ];
  int         i;
  int	      len;

  memset(buffer, ' ', MAX_BUFF - 1);
  buffer[MAX_BUFF - 1] = '\0';

  status = sys$crembx(1, 
               &channel, 
               MAX_BUFF, 
               MAX_BUFF * 10, 
               0, 
               0, 
               &mbxName, 
               0);
  check (status);
  status = lib$get_ef(&Efn);
  check(status);
  status = sys$clref(Efn);
  check(status);

  printf ("Setting up association\n");
  status = sys$qiow(
               0, 
               channel, 
               IO$_SETMODE | IO$M_READATTN, 
               &iosb, 
               conn_ast, 
               0, 
               0, 
               0, 
               0, 
               0, 
               0, 
               0);
  check(status);
  check(iosb.iosb$w_status);

  /* Go to sleep until somebodey wants to "hear" what we have to say. */
  printf ("Waiting to accept connect request.\n");
  status = sys$waitfr(Efn);
  check(status);

  len = strlen(buffer) + 1;
  status = lib$init_timer(0);
  check (status);

  for (i = 0; i < NUM_MSGS; ++i) {
    status = sys$qiow (
             	 0, 
             	 channel, 
             	 IO$_WRITEVBLK | IO$M_NOW, 
             	 &iosb, 
             	 0, 
             	 0, 
             	 buffer, 
             	 len, 
             	 0, 
             	 0, 
             	 0, 
             	 0);
    check(status);
    check(iosb.iosb$w_status);
  };

  status = lib$show_timer(0, 0, 0, 0);
  check (status);
  return (EXIT_SUCCESS);
}


/* Connection AST routine. */
#define MAX_UNAME 12
void 
conn_ast (unsigned int event_type, unsigned int c_handle,
	  unsigned int data_len, char *data_buff,
	  unsigned int p5,
	  unsigned int p6,
	  char *p7)
{
  unsigned int status;

  /* wake up and get to work. */
  status = sys$setef(Efn);
  check(status);
}
